unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, FileCtrl, shellapi, ExtCtrls;

type
  TformMenuPrincipal = class(TForm)
    be: TStatusBar;
    txtResultado: TMemo;
    LWEB: TLabel;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    txtCarpeta: TEdit;
    StaticText1: TStaticText;
    bIniciar: TButton;
    txtNombreFichero: TEdit;
    bp: TProgressBar;
    Splitter1: TSplitter;
    procedure bIniciarClick(Sender: TObject);
    procedure LWEBClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.dfm}

function obtenerUltimaCarpeta (ruta : string) : string;
var
  i : integer;
  ultimaRuta : string;
begin
  ultimaRuta := '';
  for i := length (ruta) downto 0 do
  begin
    if ruta[i] <> '\' then
      ultimaRuta := ruta[i] + ultimaRuta
    else
      break;
  end;
  Result := ultimaRuta;
end;

function listaSubcarpetasRuta (rutaBase : string) : TStringList;
var
  i, j : integer;
  obtenidaUltima : boolean;
  listaCarpetasTMP : TStringList;
  carpetasV : TDirectoryListBox;
begin
  carpetasV := TDirectoryListBox.Create (
      Application.MainForm);
  carpetasV.Parent := Application.MainForm;
  carpetasV.Directory := rutaBase;
  carpetasV.Visible := false;

  listaCarpetasTMP := TStringList.Create;
  for i := 0 to carpetasV.Count - 1 do
  begin
    //para no coger las subcarpetas anteriores
    if (ExcludeTrailingPathDelimiter (
        obtenerUltimaCarpeta (rutaBase)) = carpetasV.Items[i]) then
      obtenidaUltima := true
    else
      obtenidaUltima := false;
    if obtenidaUltima then
    begin
      for j := i + 1 to carpetasV.Count - 1 do
        listaCarpetasTMP.Add (carpetasV.Items[j]);
    end;
  end;
  result := listaCarpetasTMP;
end;


procedure TformMenuPrincipal.bIniciarClick(Sender: TObject);
var
  carpetasRecorrer : TStringList;
  i, numFicherosOk, numFicherosError : integer;
  origen, destino : string;
begin
  be.Panels[1].Text := 'Iniciando copia';
  be.Refresh;
  txtResultado.Clear;
  carpetasRecorrer := listaSubcarpetasRuta (txtCarpeta.Text);
  numFicherosOk := 0;
  numFicherosError := 0;
  bp.Min := 0;
  bp.Max := carpetasRecorrer.Count - 1;
  bp.Position := 0;
  for i := 0 to carpetasRecorrer.Count - 1 do
  begin
    bp.Position := i;
    bp.Refresh;
    origen := IncludeTrailingPathDelimiter (txtCarpeta.Text) +
        carpetasRecorrer[i] + '\' + txtNombreFichero.Text;
    destino := IncludeTrailingPathDelimiter (txtCarpeta.Text) +
        carpetasRecorrer[i] + ExtractFileExt(txtNombreFichero.Text);
    be.Panels[1].Text := 'Copiando a ' + destino;
    be.Refresh;
    if CopyFile(pchar(origen), pchar(destino), false) then
    begin
      txtResultado.Lines.Add('Copiado: ' + origen + ' -> ' + destino);
      numFicherosOk := numFicherosOk + 1;
    end
    else
    begin
      txtResultado.Lines.Add('Error: ' + origen + ' -> ' +
          destino + '<--> ' + SysErrorMessage(getlasterror));
      numFicherosError := numFicherosError + 1;
    end;
  end;
  be.Panels[0].Text := 'OK: ' + IntToStr(numFicherosOk) +
      ' | E: ' + IntToStr(numFicherosError);
  be.Panels[1].Text := 'Copia finalizada';
  be.Refresh;
end;

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar(LWEB.CAPTION),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.
